#include "sut.h"
/*
   This routine generates a name from the number.  The names are provided 
   from the same file the is used by the shell scripts.

 */

#include "hosts.h"

/* Eventually, the context could be the table with the valid elements in it */
char *SUT_HostName( num, ctx )
int  num;
void *ctx;
{
if (num < 1 || num > local_num) {
    fprintf( stderr, "Invalid args to SUT_HostName\n" );
    return 0;
    }
return local_names[num-1];
}

int SUT_Num_hosts()
{
return local_num;
}

/* Returns my node number, -1 if can not be determined */
int SUT_Mynodenum( )
{
char myname[MAXHOSTNAMELEN];
char *p;
int  i, len;
gethostname( myname, MAXHOSTNAMELEN );

/* Try to find the name in the list of names */
for (i=0; i<local_num; i++) {
    if (strcmp( myname, local_names[i]) == 0) return i + 1;
    }
/* Strip any domain names and try again */
#ifndef SUT_KEEP_DOMAINS
p = myname;
while (*p && *p != '.') p++;
    *p = 0;
len = strlen( myname );
for (i=0; i<local_num; i++) {
    if (strncmp( myname, local_names[i], len ) == 0 &&
	(local_names[i][len] == 0 || local_names[i][len] == '.'))
	return i + 1;
    }
#endif
return -1;
}

/* Get the length of the longest name */
int SUT_Max_name_len( )
{
int i, len = 0, t;
for (i=0; i<local_num; i++) {
    if ((t = strlen(local_names[i])) > len) len = t;
    }
return len;
}
